Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/BufferInterpolation.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/BufferInterpolation.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/BufferInterpolation.java	(revision 43867)
@@ -194,6 +194,7 @@
         } else {
             status.push();
         }
+        status.add();
         try {
             int rows = target.getRows();
             int columns = target.getColumns();
@@ -201,25 +202,25 @@
             double pxSizeX = (double) source.getColumns() / (double) columns;
             double pxSizeY = (double) source.getRows() / (double) rows;
 
-            status.setRangeOfValues(0, source.getBandCount() * source.getRows() * source.getColumns());
-            status.message("Calculating interpolation");
-            int count = 0;
             double posX, posY;
             double dx = 0D, dy = 0D;
-
-            for (int iBand = 0; iBand < source.getBandCount(); iBand++) {
+            int bandCount = source.getBandCount();
+            for (int iBand = 0; iBand < bandCount; iBand++) {
+                status.setRangeOfValues(0, source.getRows());
+                status.message("Interpolating, band "+iBand+"/"+ bandCount);
+                status.setCurValue(0);
                 posY = pxSizeY / 2D;
                 Band sourceBand = source.getBand(iBand);
                 Band targetBand = target.getBand(iBand);
                 for (int iRow = 0; iRow < rows; iRow++) {
+                    status.setCurValue(iRow);
+                    if (status.isCancelled()) {
+                        status.abort();
+                        return;
+                    }
                     dy = posY - ((int) posY);
                     posX = pxSizeX / 2D;
                     for (int iCol = 0; iCol < columns; iCol++) {
-                        status.setCurValue(count++);
-                        if (status.isCancelled()) {
-                            status.abort();
-                            return;
-                        }
                         dx = posX - ((int) posX);
                         try {
                             double[] kernel = getKernel((int) posY, (int) posX, sourceBand);
@@ -245,7 +246,6 @@
             status.abort();
             throw e;
         }
-        return;
     }
 
     /**
@@ -374,7 +374,7 @@
             double pxSizeX = (double) source.getColumns() / (double) columns;
             double pxSizeY = (double) source.getRows() / (double) rows;
 
-            status.setRangeOfValues(0, source.getBandCount() * source.getRows() * source.getColumns());
+            status.setRangeOfValues(0, source.getRows()*source.getBandCount());
             status.message("Calculating interpolation");
             int count = 0;
             double posX, posY;
@@ -385,14 +385,14 @@
                 Band sourceBand = source.getBand(iBand);
                 Band targetBand = target.getBand(iBand);
                 for (int iRow = 0; iRow < rows; iRow++) {
+                    status.setCurValue(count++);
+                    if (status.isCancelled()) {
+                        status.abort();
+                        return;
+                    }
                     dy = posY - ((int) posY);
                     posX = pxSizeX / 2D;
                     for (int iCol = 0; iCol < columns; iCol++) {
-                        status.setCurValue(count++);
-                        if (status.isCancelled()) {
-                            status.abort();
-                            return;
-                        }
                         dx = posX - ((int) posX);
                         try {
                             double[][] submatrix = get4x4Submatrix(((int) posY), ((int) posX), source, sourceBand);
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/operations/linearstretchenhancement/LinearStretchEnhancementOperation.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/operations/linearstretchenhancement/LinearStretchEnhancementOperation.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/operations/linearstretchenhancement/LinearStretchEnhancementOperation.java	(revision 43867)
@@ -140,12 +140,19 @@
     @Override
     public void process() throws ProcessingOperationException {
         super.process();
-        for (int band=0; band<this.getInputBuffer().getBandCount(); band++){
+        int bandCount = this.getInputBuffer().getBandCount();
+        int rowCount = this.getInputBuffer().getRows();
+        for (int band=0; band<bandCount; band++){
             if (this.getBandsToProcess().contains(band)) {
+                this.getTaskStatus().setRangeOfValues(0, rowCount);
+                this.getTaskStatus().setCurValue(0);
+                this.getTaskStatus().message("LinearStretch band "+band+"/"+bandCount);
+
                 Band bufferBand = this.getInputBuffer().getBand(band);
                 Band outputBufferBand = this.getOutputBuffer().getBand(band);
 
-                for (int row = 0; row < this.getInputBuffer().getRows(); row++) {
+                for (int row = 0; row < rowCount; row++) {
+                    this.getTaskStatus().setCurValue(row);
                     Object rowBuffer = bufferBand.createRowBuffer();
                     bufferBand.fetchRow(row, rowBuffer);
 
@@ -164,6 +171,7 @@
                 }
             }
         }
+        this.getTaskStatus().terminate();
     }
 
     @Override
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/operations/DefaultOperationList.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/operations/DefaultOperationList.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/operations/DefaultOperationList.java	(revision 43867)
@@ -57,7 +57,7 @@
 import org.gvsig.tools.persistence.PersistenceManager;
 import org.gvsig.tools.persistence.PersistentState;
 import org.gvsig.tools.persistence.exception.PersistenceException;
-import org.gvsig.tools.task.TaskStatus;
+import org.gvsig.tools.task.SimpleTaskStatus;
 
 
 /**
@@ -249,7 +249,7 @@
     }
 
     @Override
-    public Buffer execute(TaskStatus status, Buffer buffer) throws BufferOperationException {
+    public Buffer execute(SimpleTaskStatus status, Buffer buffer) throws BufferOperationException {
         Buffer tmpBuffer1 = buffer;
         DisposeUtils.bind(tmpBuffer1);
         Buffer tmpBuffer2;
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/OperationManager.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/OperationManager.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/OperationManager.java	(revision 43867)
@@ -30,7 +30,7 @@
 import org.gvsig.raster.lib.buffer.api.operations.OperationList;
 import org.gvsig.raster.lib.buffer.api.operations.OperationListEntry;
 import org.gvsig.tools.dynobject.DynObject;
-import org.gvsig.tools.task.TaskStatus;
+import org.gvsig.tools.task.SimpleTaskStatus;
 
 
 /**
@@ -93,7 +93,7 @@
      * @return the buffer result of executing the operation
      * @throws BufferOperationException
      */
-    public Buffer execute (TaskStatus status, String name, Buffer buffer, DynObject parameters) throws BufferOperationException;
+    public Buffer execute (SimpleTaskStatus status, String name, Buffer buffer, DynObject parameters) throws BufferOperationException;
 
 
 };
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/operations/OperationList.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/operations/OperationList.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/operations/OperationList.java	(revision 43867)
@@ -30,7 +30,7 @@
 import org.gvsig.tools.observer.WeakReferencingObservable;
 import org.gvsig.tools.persistence.Persistent;
 import org.gvsig.tools.lang.Cloneable;
-import org.gvsig.tools.task.TaskStatus;
+import org.gvsig.tools.task.SimpleTaskStatus;
 
 
 /**
@@ -45,7 +45,7 @@
      * @return the buffer result of executing the operations list in chained fashion
      * @throws BufferOperationException
      */
-    public Buffer execute(TaskStatus status, Buffer buffer) throws BufferOperationException;
+    public Buffer execute(SimpleTaskStatus status, Buffer buffer) throws BufferOperationException;
 
     /**
      * @param operation
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/operations/Operation.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/operations/Operation.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/operations/Operation.java	(revision 43867)
@@ -25,6 +25,7 @@
 import org.gvsig.raster.lib.buffer.api.Buffer;
 import org.gvsig.raster.lib.buffer.api.exceptions.BufferOperationException;
 import org.gvsig.tools.dynobject.DynObject;
+import org.gvsig.tools.task.SimpleTaskStatus;
 import org.gvsig.tools.task.TaskStatus;
 
 
@@ -41,7 +42,7 @@
      * @return the buffer result of executing the operation
      * @throws BufferOperationException
      */
-    public Buffer execute(TaskStatus status, Buffer buffer, DynObject parameters) throws BufferOperationException;
+    public Buffer execute(SimpleTaskStatus status, Buffer buffer, DynObject parameters) throws BufferOperationException;
 
     /**
      * @return the factory
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/statistics/Statistics.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/statistics/Statistics.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.api/src/main/java/org/gvsig/raster/lib/buffer/api/statistics/Statistics.java	(revision 43867)
@@ -117,7 +117,6 @@
      * desde el principio del array ordenado y desde el final de él (mínimo y máximo).
      *
      * @param percent Porcentaje de recorte
-     * @param valueByBand array bidimensional de enteros o doubles. Depende del tipo de dato del raster.
      * @return El valor de recorte de colas para el porcentaje dado
      */
     public double[][] getTailTrimValue(double percent);
@@ -129,7 +128,6 @@
      * raster (o una muestra de ellos) y devolver el valor que corresponde al porcentaje comenzando
      * desde el principio del array ordenado y desde el final de él (mínimo y máximo).
      * @param pos posición de recorte
-     * @param valueByBand array bidimensional de enteros o doubles. Depende del tipo de dato del raster.
      * @return el valor de recorte de colas para la posición dada
      */
     public double[][] getTailTrimValue(int pos);
@@ -144,9 +142,6 @@
      * Throws the thread which figure out statistics
      * @param status
      * @param bands
-     * @throws FileNotOpenException
-     * @throws RasterDriverException
-     * @throws ProcessInterruptedException
      */
     public void calculate(SimpleTaskStatus status, List<Band> bands); //¿¿¿ scale ???
 
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/AbstractOperation.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/AbstractOperation.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/AbstractOperation.java	(revision 43867)
@@ -28,7 +28,7 @@
 import org.gvsig.raster.lib.buffer.spi.exceptions.ProcessingOperationException;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dynobject.DynObject;
-import org.gvsig.tools.task.TaskStatus;
+import org.gvsig.tools.task.SimpleTaskStatus;
 import org.gvsig.tools.task.TaskStatusManager;
 
 
@@ -44,7 +44,7 @@
     private DynObject parameters;
     private Buffer outputBuffer;
     private final OperationFactory factory;
-    private TaskStatus taskStatus;
+    private SimpleTaskStatus taskStatus;
 
     private boolean copyUnprocessedBands;
 
@@ -71,11 +71,13 @@
     }
 
     @Override
-    public TaskStatus getTaskStatus() {
+    public SimpleTaskStatus getTaskStatus() {
         if( this.taskStatus==null ) {
             TaskStatusManager taskStatusManager = ToolsLocator.getTaskStatusManager();
             this.taskStatus = taskStatusManager.createDefaultSimpleTaskStatus(
                 this.getFactory().getName());
+            this.taskStatus.setAutoremove(true);
+            this.taskStatus.add();
         }
         return this.taskStatus;
     }
@@ -95,14 +97,23 @@
      * @see org.gvsig.raster.lib.buffer.api.Operation#execute(org.gvsig.raster.lib.buffer.api.Buffer, org.gvsig.tools.dynobject.DynObject)
      */
     @Override
-    public Buffer execute(TaskStatus status, Buffer buffer, DynObject parameters) throws BufferOperationException {
+    public Buffer execute(SimpleTaskStatus status, Buffer buffer, DynObject parameters) throws BufferOperationException {
         this.buffer = buffer;
         this.parameters = parameters;
         this.taskStatus = status;
-        this.preProcess();
-        this.process();
-        this.postProcess();
-        return this.getOutputBuffer();
+        try {
+            this.taskStatus.push();
+            
+            this.preProcess();
+            this.process();
+            this.postProcess();
+            return this.getOutputBuffer();
+        } finally {
+            if( this.taskStatus.isRunning() ) {
+                this.taskStatus.terminate();
+            }
+            this.taskStatus.pop();
+        }
     }
 
     /* (non-Javadoc)
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/OperationServices.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/OperationServices.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/OperationServices.java	(revision 43867)
@@ -26,6 +26,7 @@
 import org.gvsig.raster.lib.buffer.api.exceptions.BufferOperationException;
 import org.gvsig.raster.lib.buffer.api.operations.Operation;
 import org.gvsig.tools.dynobject.DynObject;
+import org.gvsig.tools.task.SimpleTaskStatus;
 import org.gvsig.tools.task.TaskStatus;
 
 
@@ -73,5 +74,5 @@
      */
     void postProcess() throws BufferOperationException;
 
-    TaskStatus getTaskStatus();
+    SimpleTaskStatus getTaskStatus();
 }
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/AbstractSpecifiedBandsOperation.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/AbstractSpecifiedBandsOperation.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.spi/src/main/java/org/gvsig/raster/lib/buffer/spi/operations/AbstractSpecifiedBandsOperation.java	(revision 43867)
@@ -24,7 +24,6 @@
 
 import java.util.ArrayList;
 import java.util.List;
-import org.gvsig.raster.lib.buffer.api.Buffer;
 import org.gvsig.raster.lib.buffer.api.NoData;
 
 import org.gvsig.raster.lib.buffer.api.exceptions.BufferOperationException;
